Bug 856363 - Issues with createrepo -v and sha1
Issues with createrepo -v and sha1
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: createrepo (Show other bugs)
16
All Linux
unspecified Severity low
: ---
: ---
Assigned To: Fedora Packaging Toolset Team
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-11 17:29 EDT by Michael Sphar
Modified: 2014-01-21 18:23 EST (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 734510
Environment:
Last Closed: 2013-02-13 21:09:59 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Michael Sphar 2012-09-11 17:29:51 EDT
+++ This bug was initially created as a clone of Bug #734510 +++

Description of problem:

-v causes createrepo to never finish
sha1 should be default; all older releases will not return chksum errors when your createrepo  (ie: rhel5u3 and rhel5u5)

Version-Release number of selected component (if applicable):
Fedora 15 - yum server
RHEL5U3 - client server
RHEL5U5 - client server

How reproducible:

1.  Run createrepo -v /home/rpms/rhel5_5  on fedora 15  - fails to finsh

2.  Run createrepo /home/rpms/rhel5_5  with no options   - doesnt work with rhel5u5

yum clean all and yum list on rhel5u5 server comes back with checksum error

3.  Then run createrepo -s sha1 /home/rpms/rhel5_5  

yum clean all and yum list run with no issues

--- Additional comment from svidal@redhat.com on 2011-08-30 12:44:02 EDT ---

okay - you seem to be conflating two different things here:

If you could provide the following info:

1. rpm -q createrepo yum


2. strace -f createrepo -v /home/rpms/rhel5_5



the -s item is not a bug and is working entirely as it is intended.

--- Additional comment from jason.cae@gmail.com on 2011-08-31 10:00:30 EDT ---

So the default behaviour for createrepo on a RHEL5 package set is to create a repo with sha256 which does not work with RHEL5's python?  You would think we would error on the side of backwards compatibility; rather then push sha256 for something as agnostic as a checksum.


[root@yum ~]# rpm -q createrepo yum
createrepo-0.9.9-4.fc15.noarch
yum-3.2.29-9.fc15.noarch
[root@yum ~]# 

working on strace.

--- Additional comment from jason.cae@gmail.com on 2011-08-31 10:03:20 EDT ---

Here a window output; let me know if you want the whole thing and I can split it to a file output.

[pid 14333] stat("/home/rpms/rhel5_5/ruby-ri-1.8.5-5.el5_4.8.x86_64.rpm", {st_mode=S_IFREG|0755, st_size=1772663, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/ruby-ri-1.8.5-5.el5_4.8.x86_64.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=1772663, ...}) = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1ruby-ri-1.8.5-5.el5_4."..., 65536) = 65536
[pid 14333] read(9, "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"..., 65536) = 65536
[pid 14333] read(9, "88791918e6d77194ea6b\000474546d6bf0"..., 65536) = 65536
[pid 14333] read(9, "599f4c51cb8288ab9c3cc5\00027c91b884"..., 65536) = 65536
[pid 14333] read(9, "0dcbd34339e5574a2c74f259\00037d353f"..., 65536) = 65536
[pid 14333] read(9, "cce6ebfb0640f4d723d3a7aa64\0009650e"..., 65536) = 65536
[pid 14333] read(9, "cae57b0b6e8345f9c7cf7208f74a\0f15"..., 65536) = 65536
[pid 14333] read(9, "ot\0root\0root\0root\0root\0root\0root"..., 65536) = 65536
[pid 14333] read(9, "t\0root\0root\0root\0root\0root\0root\0"..., 65536) = 65536
[pid 14333] read(9, "dded ruby_cvs.2000100218.patch\n "..., 65536) = 65536
[pid 14333] read(9, "\0\30\0\375\0\30\0\376\0\30\0\377\0\30\1\0\0\30\1\1\0\30\1\2\0\30\1\3\0\30\1\4"..., 65536) = 65536
[pid 14333] read(9, "yaml\0%26-i.yaml\0%5e-i.yaml\0%7c-i"..., 65536) = 65536
[pid 14333] read(9, "l_name-i.yaml\0maker_target-i.yam"..., 65536) = 65536
[pid 14333] read(9, "argetnamespace-i.yaml\0basetype-i"..., 65536) = 65536
[pid 14333] read(9, "ing/\0/usr/share/ri/1.8/system/SO"..., 65536) = 65536
[pid 14333] read(9, "\0\0\0\5\0\0\0\n\0\0\0\5\0\0\0\5\0\0\0\n\0\0\0\n\0\0\0\6\0\0\0\5"..., 65536) = 65536
[pid 14333] read(9, "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"..., 65536) = 65536
[pid 14333] read(9, "\22A\352\201\240\267\323\316%\305:5MHqO\353\274\333\351uw;\371\244\270\231G\307{\255\204"..., 65536) = 65536
[pid 14333] read(9, "\340\367O\275O\301\346\335\235\356\307\315\340n\320\v>W\n\262\37\36\331\252\236\303\343\312\357\260\276N"..., 65536) = 65536
[pid 14333] read(9, "\342\370\303l*H\265\na\3011J\340\315\363'\375\356n\257L\4\323Ze\305j\251\"K.\1"..., 65536) = 65536
[pid 14333] read(9, "\346\34,6\315\320h\244\317\333\371X[{U\344.\312\256m+\2153d\342\324\373\336\331) k"..., 65536) = 65536
[pid 14333] read(9, "\265\343\4\0170\273NQ\224\5\255\306e9\23\232C\201c\301b8O\210\242\241*F\203&\263,"..., 65536) = 65536
[pid 14333] read(9, "g\377\0~S\317\33V\333Cx\237[\247)\267\225\347v\323\37\343s \241\243\303\252\347v[\312"..., 65536) = 65536
[pid 14333] read(9, "\364s\357\330\301\315Vek\210\357n<\253\1\245$\253\30\346\377tu$\372\306\222\30\320>6\326"..., 65536) = 65536
[pid 14333] read(9, "\374\323\253\313\371\325\233\327\317^|\227\236\252\27\230\3412\6\270\243h\222\35=\320|\343\233g\317/"..., 65536) = 65536
[pid 14333] read(9, "\266\273\26\237\340}\261\324;ud\7v\347k\376\rZ2\274\241\237\273\266?\250\t~\375\344\307\17"..., 65536) = 65536
[pid 14333] read(9, "\343\337\322\203)\334\301\356\217f\356\304N\212,\324zg\275\\\30\270\32\5\16\237$|\212\2718d"..., 65536) = 65536
[pid 14333] read(9, "]b\376\242\361\266\341\332\35\20\327\256\342p\356\322\337\f>\255\314*\235\337\233\360l\304o|\366\233"..., 65536) = 3191
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] close(9)                    = 0
[pid 14333] open("/home/rpms/rhel5_5/ruby-ri-1.8.5-5.el5_4.8.x86_64.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=1772663, ...}) = 0
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=1772663, ...}) = 0
[pid 14333] mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7f12e3fdf000
[pid 14333] lseek(9, 0, SEEK_SET)       = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1ruby-ri-1.8.5-5.el5_4."..., 104) = 104
[pid 14333] read(9, "\0\0\0\7\0\0\0\330\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7"..., 4096) = 4096
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 456, SEEK_SET)     = 456
[pid 14333] close(9)                    = 0
[pid 14333] munmap(0x7f12e3fdf000, 4096) = 0
[pid 14333] write(6, "cation href=\"desktop-file-utils-"..., 4096) = 4096
[pid 14333] brk(0)                      = 0x1fc0000
[pid 14333] brk(0x1fe4000)              = 0x1fe4000
[pid 14333] write(7, "6\">\n    <version epoch=\"0\" ver=\""..., 4096) = 4096
[pid 14333] write(7, "/%3d%3d-i.yaml</file>\n    <file>"..., 671744) = 671744
[pid 14333] write(8, "hangelog author=\"Michal Hlavinka"..., 4096) = 4096
[pid 14333] stat("/home/rpms/rhel5_5/ant-apache-oro-1.6.5-2jpp.2.x86_64.rpm", {st_mode=S_IFREG|0755, st_size=127470, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/ant-apache-oro-1.6.5-2jpp.2.x86_64.rpm", O_RDONLY) = 9
[pid 14333] dup(9)                      = 10
[pid 14333] read(10, "\355\253\356\333\3\0\0\0\0\1ant-apache-oro-1.6.5-2"..., 96) = 96
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0\7\0\0\0\330", 16) = 16
[pid 14333] read(10, "\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7\0\0\0\0\0\0\0A"..., 328) = 328
[pid 14333] fstat(10, {st_mode=S_IFREG|0755, st_size=127470, ...}) = 0
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0F\0\0Jt", 16) = 16
[pid 14333] read(10, "\0\0\0?\0\0\0\7\0\0Jd\0\0\0\20\0\0\0d\0\0\0\10\0\0\0\0\0\0\0\2"..., 20180) = 20180
[pid 14333] close(10)                   = 0
[pid 14333] close(9)                    = 0
[pid 14333] stat("/home/rpms/rhel5_5/ant-apache-oro-1.6.5-2jpp.2.x86_64.rpm", {st_mode=S_IFREG|0755, st_size=127470, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/ant-apache-oro-1.6.5-2jpp.2.x86_64.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=127470, ...}) = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1ant-apache-oro-1.6.5-2"..., 65536) = 65536
[pid 14333] read(9, "\330\253kn(`\327L<\335e\23\346u\203u\353`\341(\236C)O\227[m\363\234\207\326\22"..., 65536) = 61934
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] close(9)                    = 0
[pid 14333] open("/home/rpms/rhel5_5/ant-apache-oro-1.6.5-2jpp.2.x86_64.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=127470, ...}) = 0
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=127470, ...}) = 0
[pid 14333] mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7f12e3fdf000
[pid 14333] lseek(9, 0, SEEK_SET)       = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1ant-apache-oro-1.6.5-2"..., 104) = 104
[pid 14333] read(9, "\0\0\0\7\0\0\0\330\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7"..., 4096) = 4096
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 456, SEEK_SET)     = 456
[pid 14333] close(9)                    = 0
[pid 14333] munmap(0x7f12e3fdf000, 4096) = 0
[pid 14333] stat("/home/rpms/rhel5_5/jakarta-commons-daemon-javadoc-1.0.1-6jpp.1.x86_64.rpm", {st_mode=S_IFREG|0755, st_size=24640, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/jakarta-commons-daemon-javadoc-1.0.1-6jpp.1.x86_64.rpm", O_RDONLY) = 9
[pid 14333] dup(9)                      = 10
[pid 14333] read(10, "\355\253\356\333\3\0\0\0\0\1jakarta-commons-daemon"..., 96) = 96
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0\7\0\0\0\330", 16) = 16
[pid 14333] read(10, "\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7\0\0\0\0\0\0\0A"..., 328) = 328
[pid 14333] fstat(10, {st_mode=S_IFREG|0755, st_size=24640, ...}) = 0
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0?\0\0\34N", 16) = 16
[pid 14333] read(10, "\0\0\0?\0\0\0\7\0\0\34>\0\0\0\20\0\0\0d\0\0\0\10\0\0\0\0\0\0\0\1"..., 8254) = 8254
[pid 14333] close(10)                   = 0
[pid 14333] close(9)                    = 0
[pid 14333] stat("/home/rpms/rhel5_5/jakarta-commons-daemon-javadoc-1.0.1-6jpp.1.x86_64.rpm", {st_mode=S_IFREG|0755, st_size=24640, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/jakarta-commons-daemon-javadoc-1.0.1-6jpp.1.x86_64.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=24640, ...}) = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1jakarta-commons-daemon"..., 65536) = 24640
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] close(9)                    = 0
[pid 14333] open("/home/rpms/rhel5_5/jakarta-commons-daemon-javadoc-1.0.1-6jpp.1.x86_64.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=24640, ...}) = 0
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=24640, ...}) = 0
[pid 14333] mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7f12e3fdf000
[pid 14333] lseek(9, 0, SEEK_SET)       = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1jakarta-commons-daemon"..., 104) = 104
[pid 14333] read(9, "\0\0\0\7\0\0\0\330\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7"..., 4096) = 4096
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 456, SEEK_SET)     = 456
[pid 14333] close(9)                    = 0
[pid 14333] munmap(0x7f12e3fdf000, 4096) = 0
[pid 14333] write(6, " displays descriptions of built-"..., 4096) = 4096
[pid 14333] write(7, "ish-i.yaml</file>\n    <file>/usr"..., 4096) = 4096
[pid 14333] write(8, " CVE-2008-2376: Integer overflow"..., 4096) = 4096
[pid 14333] stat("/home/rpms/rhel5_5/xorg-x11-drv-dmc-1.1.0-2.x86_64.rpm", {st_mode=S_IFREG|0755, st_size=10116, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/xorg-x11-drv-dmc-1.1.0-2.x86_64.rpm", O_RDONLY) = 9
[pid 14333] dup(9)                      = 10
[pid 14333] read(10, "\355\253\356\333\3\0\0\0\0\1xorg-x11-drv-dmc-1.1.0"..., 96) = 96
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0\7\0\0\0\330", 16) = 16
[pid 14333] read(10, "\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7\0\0\0\0\0\0\0A"..., 328) = 328
[pid 14333] fstat(10, {st_mode=S_IFREG|0755, st_size=10116, ...}) = 0
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0:\0\0\tT", 16) = 16
[pid 14333] read(10, "\0\0\0?\0\0\0\7\0\0\tD\0\0\0\20\0\0\0d\0\0\0\10\0\0\0\0\0\0\0\1"..., 3316) = 3316
[pid 14333] close(10)                   = 0
[pid 14333] close(9)                    = 0
[pid 14333] stat("/home/rpms/rhel5_5/xorg-x11-drv-dmc-1.1.0-2.x86_64.rpm", {st_mode=S_IFREG|0755, st_size=10116, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/xorg-x11-drv-dmc-1.1.0-2.x86_64.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=10116, ...}) = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1xorg-x11-drv-dmc-1.1.0"..., 65536) = 10116
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] close(9)                    = 0
[pid 14333] open("/home/rpms/rhel5_5/xorg-x11-drv-dmc-1.1.0-2.x86_64.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=10116, ...}) = 0
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=10116, ...}) = 0
[pid 14333] mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7f12e3fdf000
[pid 14333] lseek(9, 0, SEEK_SET)       = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1xorg-x11-drv-dmc-1.1.0"..., 104) = 104
[pid 14333] read(9, "\0\0\0\7\0\0\0\330\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7"..., 4096) = 4096
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 456, SEEK_SET)     = 456
[pid 14333] close(9)                    = 0
[pid 14333] munmap(0x7f12e3fdf000, 4096) = 0
[pid 14333] stat("/home/rpms/rhel5_5/gamin-devel-0.1.7-8.el5.i386.rpm", {st_mode=S_IFREG|0755, st_size=36186, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/gamin-devel-0.1.7-8.el5.i386.rpm", O_RDONLY) = 9
[pid 14333] dup(9)                      = 10
[pid 14333] read(10, "\355\253\356\333\3\0\0\0\0\1gamin-devel-0.1.7-8.el"..., 96) = 96
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0\7\0\0\0\330", 16) = 16
[pid 14333] read(10, "\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7\0\0\0\0\0\0\0A"..., 328) = 328
[pid 14333] fstat(10, {st_mode=S_IFREG|0755, st_size=36186, ...}) = 0
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0>\0\0#k", 16) = 16
[pid 14333] read(10, "\0\0\0?\0\0\0\7\0\0#[\0\0\0\20\0\0\0d\0\0\0\10\0\0\0\0\0\0\0\1"..., 10059) = 10059
[pid 14333] close(10)                   = 0
[pid 14333] close(9)                    = 0
[pid 14333] stat("/home/rpms/rhel5_5/gamin-devel-0.1.7-8.el5.i386.rpm", {st_mode=S_IFREG|0755, st_size=36186, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/gamin-devel-0.1.7-8.el5.i386.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=36186, ...}) = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1gamin-devel-0.1.7-8.el"..., 65536) = 36186
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] close(9)                    = 0
[pid 14333] open("/home/rpms/rhel5_5/gamin-devel-0.1.7-8.el5.i386.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=36186, ...}) = 0
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=36186, ...}) = 0
[pid 14333] mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7f12e3fdf000
[pid 14333] lseek(9, 0, SEEK_SET)       = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1gamin-devel-0.1.7-8.el"..., 104) = 104
[pid 14333] read(9, "\0\0\0\7\0\0\0\330\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7"..., 4096) = 4096
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 456, SEEK_SET)     = 456
[pid 14333] close(9)                    = 0
[pid 14333] munmap(0x7f12e3fdf000, 4096) = 0
[pid 14333] write(8, "angelog>\n<changelog author=\"Rand"..., 4096) = 4096
[pid 14333] stat("/home/rpms/rhel5_5/libXvMC-devel-1.0.2-2.1.i386.rpm", {st_mode=S_IFREG|0755, st_size=7271, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/libXvMC-devel-1.0.2-2.1.i386.rpm", O_RDONLY) = 9
[pid 14333] dup(9)                      = 10
[pid 14333] read(10, "\355\253\356\333\3\0\0\0\0\1libXvMC-devel-1.0.2-2."..., 96) = 96
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0\7\0\0\0\330", 16) = 16
[pid 14333] read(10, "\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7\0\0\0\0\0\0\0A"..., 328) = 328
[pid 14333] fstat(10, {st_mode=S_IFREG|0755, st_size=7271, ...}) = 0
[pid 14333] read(10, "\216\255\350\1\0\0\0\0\0\0\0=\0\0\0210", 16) = 16
[pid 14333] read(10, "\0\0\0?\0\0\0\7\0\0\21 \0\0\0\20\0\0\0d\0\0\0\10\0\0\0\0\0\0\0\1"..., 5376) = 5376
[pid 14333] close(10)                   = 0
[pid 14333] close(9)                    = 0
[pid 14333] stat("/home/rpms/rhel5_5/libXvMC-devel-1.0.2-2.1.i386.rpm", {st_mode=S_IFREG|0755, st_size=7271, ...}) = 0
[pid 14333] open("/home/rpms/rhel5_5/libXvMC-devel-1.0.2-2.1.i386.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=7271, ...}) = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1libXvMC-devel-1.0.2-2."..., 65536) = 7271
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] read(9, "", 65536)          = 0
[pid 14333] close(9)                    = 0
[pid 14333] open("/home/rpms/rhel5_5/libXvMC-devel-1.0.2-2.1.i386.rpm", O_RDONLY) = 9
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=7271, ...}) = 0
[pid 14333] fstat(9, {st_mode=S_IFREG|0755, st_size=7271, ...}) = 0
[pid 14333] mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7f12e3fdf000
[pid 14333] lseek(9, 0, SEEK_SET)       = 0
[pid 14333] read(9, "\355\253\356\333\3\0\0\0\0\1libXvMC-devel-1.0.2-2."..., 104) = 104
[pid 14333] read(9, "\0\0\0\7\0\0\0\330\0\0\0>\0\0\0\7\0\0\0\310\0\0\0\20\0\0\1\v\0\0\0\7"..., 4096) = 4096
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 4200, SEEK_SET)    = 4200
[pid 14333] lseek(9, 456, SEEK_SET)     = 456
[pid 14333] close(9)                    = 0
[pid 14333] munmap(0x7f12e3fdf000, 4096) = 0
[pid 14333] write(6, " <url>http://jakarta.apache.org/"..., 4096) = 4096
[pid 14333] stat("/home/rpms/rhel5_5/tsclient-0.148-6.el5.x86_64.rpm", {st_mode=S_IFREG|0755, st_size=334226, ...}) = 0
[pid 14333] write(1, "rpm\nreading libgcrypt-1.4.4-5.el"..., 4096) = ? ERESTARTSYS (To be restarted)
[pid 14332] <... read resumed> 0x1cc2133, 1) = ? ERESTARTSYS (To be restarted)
[pid 14333] --- {si_signo=SIGWINCH, si_code=SI_KERNEL} (Window changed) ---
[pid 14332] --- {si_signo=SIGWINCH, si_code=SI_KERNEL} (Window changed) ---
[pid 14333] write(1, "rpm\nreading libgcrypt-1.4.4-5.el"..., 4096 <unfinished ...>
[pid 14332] read(8,  <unfinished ...>
[pid 14333] <... write resumed> )       = ? ERESTARTSYS (To be restarted)
[pid 14332] <... read resumed> 0x1cc2133, 1) = ? ERESTARTSYS (To be restarted)
[pid 14333] --- {si_signo=SIGWINCH, si_code=SI_KERNEL} (Window changed) ---
[pid 14332] --- {si_signo=SIGWINCH, si_code=SI_KERNEL} (Window changed) ---
[pid 14333] write(1, "rpm\nreading libgcrypt-1.4.4-5.el"..., 4096 <unfinished ...>
[pid 14332] read(8,  <unfinished ...>
[pid 14333] <... write resumed> )       = ? ERESTARTSYS (To be restarted)
[pid 14332] <... read resumed> 0x1cc2133, 1) = ? ERESTARTSYS (To be restarted)
[pid 14333] --- {si_signo=SIGWINCH, si_code=SI_KERNEL} (Window changed) ---
[pid 14332] --- {si_signo=SIGWINCH, si_code=SI_KERNEL} (Window changed) ---
[pid 14333] write(1, "rpm\nreading libgcrypt-1.4.4-5.el"..., 4096 <unfinished ...>
[pid 14332] read(8,

--- Additional comment from james.antill@redhat.com on 2011-08-31 10:13:10 EDT ---

(In reply to comment #2)
> So the default behaviour for createrepo on a RHEL5 package set is to create a
> repo with sha256 which does not work with RHEL5's python?  You would think we
> would error on the side of backwards compatibility; rather then push sha256 for
> something as agnostic as a checksum.

 There is no such thing as "a RHEL-5 package set" from createrepo's POV (and it doesn't make much sense outside of createrepo either).
 We default to sha256, if it's available.

--- Additional comment from svidal@redhat.com on 2011-08-31 10:42:45 EDT ---

Packages can be from any number of distros - there is no way for createrepo to tell where the pkgs are from and therefore what sha that distro will be able to cope with.

Since the target of fedora is not rhel5 we don't assume sha for it.

Now, on rhel5, we do.

--- Additional comment from svidal@redhat.com on 2011-08-31 10:45:30 EDT ---

we need the whole output to see where it stops.

You're saying it never finishes, which implies some sort of hang or extremely long wait.

--- Additional comment from mikesphar@gmail.com on 2012-05-11 17:13:01 EDT ---

I've been troubleshooting a similar problem. It appears to be a sort of race condition in the pipes between genpkgmetadata.py and worker.py.

Specifically, it seems related to this section from /usr/lib/python2.7/site-packages/createrepo/__init__.py:

            while gimmebreak != len(worker_jobs.keys()):
                gimmebreak = 0
                for (num,job) in worker_jobs.items():
                    if job.poll() is not None:
                        gimmebreak+=1
                    line = job.stdout.readline()
                    if line:
                        self.callback.log('Worker %s: %s' % (num, line.rstrip()))
                    line = job.stderr.readline()
                    if line:
                        self.callback.errorlog('Worker %s: %s' % (num, line.rstrip()))

With the -v option, worker.py generates a line of stdout for every package being read. However genpkgmetadata only prints the first "Worker 0: reading <package" line and doesn't print any of the further lines. It appears to be blocked on the job.stderr.readline() statement. There seems to be a point where if a large enough package list is processed, the buffer fills and worker.py is blocked on any further writes, so it never exits, and genpkgmetadata.py never exits the loop. If worker.py exits without filling the buffer everything proceeds normally.

In my case while testing I commented out the section in genpkgmetadata.py reading and printing stderr and after that not only did createrepo no longer hang, but printed out the name of every package being read by the worker as expected. (Obviously that's not the right real fix.)

When I straced the program I saw the same results as printed above, where ultimately the genpkgmetadata.py and worker.py processes get stuck in pipe_wait, with the child process attempting to write to stdout, and the parent process attempting to read file descriptor 8.

This behavior stayed the same with the latest createrepo for FC16 and when I pulled the current createrepo master from git (as of a couple days ago).

--- Additional comment from mikesphar@gmail.com on 2012-05-14 10:59:26 EDT ---

Just a minor correction that I realize I said "race condition" above when this is more appropriately described as a deadlock.

--- Additional comment from endoflife@fedoraproject.org on 2012-08-07 12:53:57 EDT ---

This message is a notice that Fedora 15 is now at end of life. Fedora
has stopped maintaining and issuing updates for Fedora 15. It is
Fedora's policy to close all bug reports from releases that are no
longer maintained. At this time, all open bugs with a Fedora 'version'
of '15' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that
we were unable to fix it before Fedora 15 reached end of life. If you
would still like to see this bug fixed and are able to reproduce it
against a later version of Fedora, you are encouraged to click on
"Clone This Bug" (top right of this page) and open it against that
version of Fedora.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

The process we are following is described here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 1 Michael Sphar 2012-09-11 17:30:38 EDT
Cloned this bug because as per my last comments in the previous bug, I reproduced this problem under Fedora 16.
Comment 2 john.haxby@oracle.com 2012-12-21 07:34:34 EST
It's also present on Fedora 17.
Comment 3 Fedora End Of Life 2013-02-13 21:10:03 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 4 Fedora Update System 2013-02-28 10:13:47 EST
createrepo-0.9.9-12.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/createrepo-0.9.9-12.fc17
Comment 5 Fedora Update System 2013-02-28 10:31:36 EST
createrepo-0.9.9-13.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/createrepo-0.9.9-13.fc18
Comment 6 Fedora Update System 2013-03-16 21:08:30 EDT
createrepo-0.9.9-13.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.